#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <limits.h>

#define err(eval, fmt, ...)	print_string(eval, 1, fmt, ## __VA_ARGS__)
#define errx(eval, fmt, ...)	print_string(eval, 0, fmt, ## __VA_ARGS__)
#define warn(fmt, ...)		print_string(-1, 0, fmt, ## __VA_ARGS__)
#define warnx(fmt, ...)		print_string(-1, 1, fmt, ## __VA_ARGS__)

void print_string(int eval, int prog, const char *fmt, ...)
{
    va_list ap;
    char line[LINE_MAX];

#ifndef HAVE___PROGNAME
    char *__progname = "ui";
#else
    extern char *__progname;
#endif

    va_start(ap, fmt);
    vsnprintf(line, sizeof(line), fmt, ap);
    va_end(ap);

    fprintf(stderr, "%s%s%s\n", (prog) ? __progname : "", (prog) ? ": " : "",
	    line);

    if (eval > -1)
	exit(eval);

    return;
}
